buildFilesystem.sh 10 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256
  1. #!/bin/bash
  2. set -x
  3. set -e
  4. # Build fs, image
  5. # This file is part of PrawnOS (http://www.prawnos.com)
  6. # Copyright (c) 2018 Hal Emmerich <hal@halemmerich.com>
  7. # PrawnOS is free software: you can redistribute it and/or modify
  8. # it under the terms of the GNU General Public License version 2
  9. # as published by the Free Software Foundation.
  10. # PrawnOS is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  13. # GNU General Public License for more details.
  14. # You should have received a copy of the GNU General Public License
  15. # along with PrawnOS. If not, see <https://www.gnu.org/licenses/>.
  16. #Ensure Sudo
  17. if [ ! $UID = "0" ]
  18. then
  19. echo "Please run this script with sudo, or as root:"
  20. echo "sudo $0 $*"
  21. exit 1
  22. fi
  23. if [ -z "$1" ]
  24. then
  25. echo "No kernel version supplied"
  26. exit 1
  27. fi
  28. if [ -z "$2" ]
  29. then
  30. echo "No debian suite supplied"
  31. exit 1
  32. fi
  33. if [ -z "$3" ]
  34. then
  35. echo "No base file system image filename supplied"
  36. exit 1
  37. fi
  38. KVER=$1
  39. DEBIAN_SUITE=$2
  40. BASE=$3
  41. outmnt=$(mktemp -d -p `pwd`)
  42. outdev=/dev/loop5
  43. install_resources=resources/InstallResources
  44. build_resources=resources/BuildResources
  45. #A hacky way to ensure the loops are properly unmounted and the temp files are properly deleted.
  46. #Without this, a reboot is sometimes required to properly clean the loop devices and ensure a clean build
  47. cleanup() {
  48. set +e
  49. umount -l $outmnt > /dev/null 2>&1
  50. rmdir $outmnt > /dev/null 2>&1
  51. losetup -d $outdev > /dev/null 2>&1
  52. umount -l $outmnt > /dev/null 2>&1
  53. rmdir $outmnt > /dev/null 2>&1
  54. losetup -d $outdev > /dev/null 2>&1
  55. #delete the base file, we didn't complete our work
  56. rm -rf $BASE
  57. echo "FILESYSTEM BUILD FAILED"
  58. exit 1
  59. }
  60. trap cleanup INT TERM EXIT
  61. #layout the partitons and write filesystem information
  62. create_image() {
  63. dd if=/dev/zero of=$1 bs=$3 count=$4 conv=sparse
  64. parted --script $1 mklabel gpt
  65. cgpt create $1
  66. kernel_start=8192
  67. kernel_size=65536
  68. cgpt add -i 1 -t kernel -b $kernel_start -s $kernel_size -l Kernel -S 1 -T 5 -P 10 $1
  69. #Now the main filesystem
  70. root_start=$(($kernel_start + $kernel_size))
  71. end=`cgpt show $1 | grep 'Sec GPT table' | awk '{print $1}'`
  72. root_size=$(($end - $root_start))
  73. cgpt add -i 2 -t data -b $root_start -s $root_size -l Root $1
  74. # $root_size is in 512 byte blocks while ext4 uses a block size of 1024 bytes
  75. losetup -P $2 $1
  76. mkfs.ext4 -F -b 1024 ${2}p2 $(($root_size / 2))
  77. # mount the / partition
  78. mount -o noatime ${2}p2 $5
  79. }
  80. build_install_crossystem() {
  81. # install crossystem
  82. apt install -y vboot-utils
  83. #install clang and pre-reqs
  84. # target unstable for now to work around #173, without breaking libinput-gestures
  85. #TODO: when package build system is available, targeting unstable won't be necessary.
  86. apt install -y -t unstable clang uuid-dev meson pkg-config cmake libcmocka-dev cargo
  87. flashmap_src=/root/flashmap
  88. mosys_src=/root/mosys
  89. mkdir $flashmap_src
  90. mkdir $mosys_src
  91. #clone flashmap, need to build libfmap
  92. git clone https://github.com/dhendrix/flashmap.git /root/flashmap
  93. cd $flashmap_src && make all
  94. cd $flashmap_src && make install
  95. ldconfig
  96. #clone mosys. Later releases start depending on the minijail library which we would have to build, and that we don't care about anyway on linux
  97. git clone https://chromium.googlesource.com/chromiumos/platform/mosys /root/mosys
  98. cd $mosys_src && git checkout release-R69-10895.B
  99. mkdir $mosys_src/build
  100. # compile the c parts
  101. cd $mosys_src && CFLAGS="-Wno-error" CC=clang meson -Darch=arm $mosys_src/build
  102. cd $mosys_src && ninja -C $mosys_src/build
  103. # install mosys so crossystem can access it. It EXPECTS it to be right here and fails otherwise...
  104. mkdir -p /usr/sbin/
  105. cp --verbose $mosys_src/build/mosys /usr/sbin/
  106. # cleanup the source
  107. rm -rf $flashmap_src
  108. rm -rf $mosys_src
  109. # cleanup the unnecessary build packages, need the noninteractive flag as -y is not enough to avoid prompting users on remove for some reason
  110. DEBIAN_FRONTEND=noninteractive apt-get purge -y --auto-remove clang meson libcmocka-dev cargo cmake pkg-config
  111. }
  112. # create a 2GB image with the Chrome OS partition layout
  113. create_image $BASE $outdev 50M 40 $outmnt
  114. # use default debootstrap mirror if none is specified
  115. if [ "$PRAWNOS_DEBOOTSTRAP_MIRROR" = "" ]
  116. then
  117. PRAWNOS_DEBOOTSTRAP_MIRROR=http://ftp.us.debian.org/debian
  118. fi
  119. # install Debian on it
  120. export DEBIAN_FRONTEND=noninteractive
  121. # need ca-certs, gnupg, openssl to handle https apt links and key adding for deb.prawnos.com
  122. qemu-debootstrap --arch armhf $DEBIAN_SUITE --include openssl,ca-certificates,gnupg,locales,init --keyring=$build_resources/debian-archive-keyring.gpg $outmnt $PRAWNOS_DEBOOTSTRAP_MIRROR
  123. chroot $outmnt passwd -d root
  124. #Place the config files and installer script and give them the proper permissions
  125. echo -n PrawnOS > $outmnt/etc/hostname
  126. cp -R $install_resources/ $outmnt/InstallResources/
  127. # and the icons for the lockscreen and app menu
  128. mkdir $outmnt/InstallResources/icons/
  129. cp $build_resources/logo/icons/icon-small.png $outmnt/InstallResources/icons/
  130. cp $build_resources/logo/icons/ascii/* $outmnt/InstallResources/icons/
  131. cp scripts/InstallScripts/* $outmnt/InstallResources/
  132. cp scripts/InstallScripts/InstallPrawnOS.sh $outmnt/
  133. chmod +x $outmnt/*.sh
  134. #Make gnome postinstall executable
  135. chmod +x $outmnt/InstallResources/Niceties/*.sh
  136. #Setup the chroot for apt
  137. #This is what https://wiki.debian.org/EmDebian/CrossDebootstrap suggests
  138. cp /etc/hosts $outmnt/etc/
  139. cp $build_resources/sources.list $outmnt/etc/apt/sources.list
  140. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list
  141. if [ "$DEBIAN_SUITE" != "sid" ]
  142. then
  143. # sid doesn't have updates or security; they're present for all other suites
  144. cat $build_resources/updates.list >> $outmnt/etc/apt/sources.list
  145. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list
  146. # sid doesn't have backports; it's present for all other suites
  147. cp $build_resources/backports.list $outmnt/etc/apt/sources.list.d/
  148. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/sources.list.d/backports.list
  149. #setup apt pinning
  150. cp $build_resources/backports.pref $outmnt/etc/apt/preferences.d/
  151. sed -i -e "s/suite/$DEBIAN_SUITE/g" $outmnt/etc/apt/preferences.d/backports.pref
  152. # Install sid (unstable) as an additional source for bleeding edge packages.
  153. cp $build_resources/sid.list $outmnt/etc/apt/sources.list.d/
  154. #setup apt pinning
  155. cp $build_resources/sid.pref $outmnt/etc/apt/preferences.d/
  156. fi
  157. if [ "$DEBIAN_SUITE" = "buster" ]
  158. then
  159. # Install bullseye (testing) as an additional source
  160. cp $build_resources/bullseye.list $outmnt/etc/apt/sources.list.d/
  161. #setup apt pinning
  162. cp $build_resources/bullseye.pref $outmnt/etc/apt/preferences.d/
  163. fi
  164. #Bring in the deb.prawnos.com gpg keyring
  165. cp $build_resources/deb.prawnos.com.gpg.key $outmnt/InstallResources/
  166. chroot $outmnt apt-key add /InstallResources/deb.prawnos.com.gpg.key
  167. chroot $outmnt apt update
  168. #Setup the locale
  169. cp $build_resources/locale.gen $outmnt/etc/locale.gen
  170. chroot $outmnt locale-gen
  171. #Install the base packages
  172. chroot $outmnt apt update
  173. chroot $outmnt apt install -y udev kmod net-tools inetutils-ping traceroute iproute2 isc-dhcp-client wpasupplicant iw alsa-utils cgpt less psmisc netcat-openbsd ca-certificates bzip2 xz-utils ifupdown nano apt-utils git kpartx gdisk parted rsync busybox-static cryptsetup bash-completion libnss-systemd libpam-cap nftables uuid-runtime libgpg-error-l10n libatm1 laptop-detect e2fsprogs-l10n vim
  174. #build and install crossystem/mosys, funky way to call the bash function inside the chroot
  175. export -f build_install_crossystem
  176. chroot $outmnt /bin/bash -ec "build_install_crossystem"
  177. #add the live-boot fstab
  178. cp -f $build_resources/external_fstab $outmnt/etc/fstab
  179. chmod 644 $outmnt/etc/fstab
  180. #Cleanup to reduce install size
  181. chroot $outmnt apt-get autoremove --purge
  182. chroot $outmnt apt-get clean
  183. #Download support for libinput-gestures
  184. #Package is copied into /InstallResources/packages
  185. chroot $outmnt apt install -y libinput-tools xdotool
  186. # target unstable for now to work around #173, without breaking libinput-gestures
  187. #TODO: when package build system is available, targeting unstable won't be necessary.
  188. chroot $outmnt apt install -y -t unstable build-essential
  189. chroot $outmnt apt-get install -y -t unstable -d xsecurelock
  190. #Download the packages to be installed by Install.sh:
  191. chroot $outmnt apt-get install -y -d xorg acpi-support lightdm tasksel dpkg librsvg2-common xorg xserver-xorg-input-libinput alsa-utils anacron avahi-daemon eject iw libnss-mdns xdg-utils lxqt crda xfce4 dbus-user-session system-config-printer tango-icon-theme xfce4-power-manager xfce4-terminal xfce4-goodies mousepad vlc libutempter0 xterm numix-gtk-theme dconf-cli dconf-editor plank network-manager-gnome network-manager-openvpn network-manager-openvpn-gnome dtrx emacs accountsservice sudo pavucontrol-qt papirus-icon-theme sysfsutils bluetooth gdm3 gnome-session dbus-user-session gnome-shell-extensions nautilus nautilus-admin file-roller gnome-software gnome-software-plugin-flatpak gedit gnome-system-monitor gnome-clocks evince gnome-logs gnome-disk-utility gnome-terminal epiphany-browser fonts-cantarell gnome-tweaks seahorse materia-gtk-theme eog
  192. #Let's try to fix offline install by including stable versions of these packages too:
  193. chroot $outmnt apt-get install -y -d libegl-mesa0 libegl1-mesa libgl1-mesa-dri libglapi-mesa libglu1-mesa libglx-mesa0
  194. #Let's download recent mesa packages from unstable
  195. chroot $outmnt apt-get install -y -t unstable -d libegl-mesa0 libegl1-mesa libgl1-mesa-dri libglapi-mesa libglu1-mesa libglx-mesa0
  196. chroot $outmnt apt-get install -d -y firefox-esr
  197. # grab chromium as well, since sound is still broken in firefox for some media
  198. chroot $outmnt apt-get install -d -y chromium
  199. #Cleanup hosts
  200. rm -rf $outmnt/etc/hosts #This is what https://wiki.debian.org/EmDebian/CrossDebootstrap suggests
  201. echo -n "127.0.0.1 PrawnOS" > $outmnt/etc/hosts
  202. # do a non-error cleanup
  203. umount -l $outmnt > /dev/null 2>&1
  204. rmdir $outmnt > /dev/null 2>&1
  205. losetup -d $outdev > /dev/null 2>&1
  206. echo "DONE!"
  207. trap - INT TERM EXIT